*! v20220525 hw
********************************************************************************
* This program generates the core figures for the draft						   *
* This version January 11, 2020		(adjusted by hw 2022-04-15)										   *
* Serdar Ozkan and Sergio Salgado											   *
********************************************************************************
*------------------------------------------------------------------------------*

*** Preamble
{

* clear 
clear
set more off

* set dirs dep on user
global maindir ="${root}"+"${sep}"
 						 																

* Where the data is stored AND get file dates
// Data on Inequality 
	global filedate="$mydate" //set to current date
	local i=1
	local filesearch = "${maindir}"+"\out\"+"${filedate}"+" Inequality"+" - "+"${vsample} P85"
	cap cd "`filesearch'"
	while _rc {
		global filedate: display %tdCY-N-D date("`c(current_date)'", "DMY") - `i'
		global filedate=strltrim("$filedate")
		local i=`i'+1
		local filesearch = "${maindir}out/${filedate} Inequality - ${vsample} P85"
		cap cd "`filesearch'"
	}
global ineqdata = "${maindir}"+"\out\"+"${filedate}"+" Inequality"+" - "+"${vsample} P85"	
// Data on Volatility
	global filedate="$mydate" //set to current date
	local i=1
	local filesearch = "${maindir}"+"\out\"+"${filedate}"+" Volatility"+" - "+"${vsample} P85"
	cap cd "`filesearch'"
	while _rc {
		global filedate: display %tdCY-N-D date("`c(current_date)'", "DMY") - `i'
		global filedate=strltrim("$filedate")
		local i=`i'+1
		local filesearch = "${maindir}out/${filedate} Volatility - ${vsample} P85"
		cap cd "`filesearch'"
	}
global voladata = "${maindir}"+"\out\"+"${filedate}"+" Volatility"+" - "+"${vsample} P85"
// Data on Mobility
	global filedate="$mydate" //set to current date
/*	Not needed
local i=1
	local filesearch = "${maindir}"+"\out\"+"${filedate}"+" Mobility"+" - "+"${vsample}"
	cap cd "`filesearch'"
	while _rc {
		global filedate: display %tdCY-N-D date("`c(current_date)'", "DMY") - `i'
		global filedate=strltrim("$filedate")
		local i=`i'+1
		local filesearch = "${maindir}out/${filedate} Mobility - ${vsample}"
		cap cd "`filesearch'"
	}
*/
global mobidata = "${maindir}"+"\out\"+"${filedate}"+" Mobility"+" - "+"${vsample} P85"		

* Where the firgures are going to be saved 
global outfolder="${mydate}"+"_"+"${vsample} - P85P${LP}"
capture noisily mkdir "$maindir${sep}figs${sep}${outfolder}"
global folderfile = "$maindir${sep}figs${sep}${outfolder}${sep}FigsPaper"
capture noisily mkdir "$maindir${sep}figs${sep}${outfolder}${sep}FigsPaper"	

* Read initialize and plotting code. Do not change myplots.do
do "$maindir/do/0_Initialize.do"
do "$maindir${sep}do${sep}myplots.do"		

* Define these variables for your dataset
global yrfirst = ${yrsample} 	// First year in the dataset 
global yrlast =  2018 		// Last year in the dataset

* Define some common charactristics of the plots 
qui do "${do}/myplotsettings.do"

* change working dir to folder with out 
cd "$maindir${sep}" // Cd to the folder containing the files
	
// Which section are we ploting 
	global figineq =  "yes"			// Inequality
	global figcoh =   "yes"			// Cohorts and initial inequality
	global figvol =   "yes"			// Volatility
	global figquan =  "no"			// Income growth heterogeneity 
	global figmob =   "no"			// Mobility
	global figtail =  "no"			// Tail 
	global figcon =   "no"			// Concentration 
	global figden =   "no"			// Density Plots

// timeframe selectio to replace the original/initial points in time, depending on short/long sample
if "$vsample"=="short" {							
	global gr_yr1=2005
	global gr_yr2=2010
	global gr_yr3=2008
	global gr_yr4=2015
	global gr_yr5=2003 //mob T+10 t1
	global gr_yr6=2008 //mob T+10 t2
	global gr_yr7=2003 //mob T+5  t1
	global gr_yr8=2011 //mob T+5  t1
} 
else if "$vsample"=="long" {
	global gr_yr1=1995
	global gr_yr2=2005
	global gr_yr3=2005
	global gr_yr4=2015
	global gr_yr5=1995 //mob T+10 t1
	global gr_yr6=2000 //mob T+10 t2
	global gr_yr9=2005 //mob T+10 t3
	global gr_yr7=1995 //mob T+5  t1
	global gr_yr8=2005 //mob T+5  t2			
} 
else if "$vsample"=="siab" {
	global gr_yr1=1995
	global gr_yr2=2005
	global gr_yr3=2005
	global gr_yr4=2015
	global gr_yr5=1980 //mob T+10 t1
	global gr_yr6=1990 //mob T+10 t2
	global gr_yr9=2000 //mob T+10 t3
	global gr_yr7=1995 //mob T+5  t1
	global gr_yr8=2005 //mob T+5  t2			
} 
}

*------------------------------------------------------------------------------*
	
//===================================================//	
//--- Inequality
//===================================================//

if "${figineq}" == "yes"{ 	

// PLOTS OF LOG EARN: The limints need to change for each variable; Better seperate them
foreach subgp in fem male {	
	
	*For residual-education earnings we are only ploting the aggregated results
	if 	"`subgp'" == "all"{
		local wlist = "logearn researne researn"			
	}	
	else {
		local wlist = "logearn" // "logearn researn"	
	}
	
	*Start main loop over variables
	foreach var of local wlist {
	
	*Which variable will be ploted
	global vari = "`var'"						 
	
	*What is the group under analysis? 
	*You can add more groups to this section 
	if "`subgp'" == "all"{
		insheet using "${ineqdata}${sep}L_`var'_sumstat.csv", clear									//!hw
		local labname = "All"
	}
	if "`subgp'" == "male"{
		insheet using "${ineqdata}${sep}L_`var'_male_sumstat.csv", clear							//!hw
		keep if male == 1	// Keep the group we want to plot 
		local labname = "Men"
	}
	
	if "`subgp'" == "fem"{
	    insheet using "${ineqdata}${sep}L_`var'_male_sumstat.csv", clear							//!hw
		keep if male == 0	// Keep the group we want to plot 
		local labname = "Women"
	}
	
	*What is the label for title 
	if "${vari}" == "logearn"{
		local labtitle = "Log Earnings"
// 		local labtitle = "log y{sub:it}"
	}
	if "${vari}" == "researn" | "${vari}" == "researne"{
		local labtitle = "Residual Log Earnings"
// 		local labtitle = "{&epsilon}{sub:it}"
	}

	*What are the x-axis limits
	local lyear = ${yrfirst}
	local ryear = ${yrlast}
	
	*Normalize Percentiles 
	gen var${vari} = sd${vari}^2
	gen p9010${vari} = p90${vari} - p10${vari}
	gen p9901${vari} = p99${vari} - p1${vari}
	gen p99901${vari} = p99_9${vari} - p1${vari}
	gen p999901${vari} = p99_99${vari} - p1${vari}
	
	gen p9990${vari} = p99${vari} - p90${vari}
	gen p999_p99${vari} = p99_9${vari} - p99${vari}
	gen p9999_p999${vari} = p99_99${vari} - p99_9${vari}
		
	gen p9505${vari} = p95${vari} - p5${vari}
	gen p9050${vari} = p90${vari} - p50${vari}
	
	gen p5010${vari} = p50${vari} - p10${vari}
	
	
	gen p8510${vari} = p85${vari} - p10${vari}
	gen p8515${vari} = p85${vari} - p15${vari}
	gen p8550${vari} = p85${vari} - p50${vari}
	gen p5015${vari} = p50${vari} - p15${vari}
	
	gen ksk${vari} = (p8550${vari} - p50${LP}${vari})/p85${LP}${vari}			// P85 hier!!!
	
	*Rescale by first year 
	foreach vv in sd$vari  var$vari p1$vari p2_5$vari p5$vari p10$vari p12_5$vari p25$vari ///
		p37_5$vari p50$vari p62_5$vari p75$vari p87_5$vari p90$vari p95$vari ///
		p97_5$vari p99$vari p99_9$vari p99_99$vari p9010$vari  p9901$vari  p9505$vari p9050${vari} p5010${vari} ksk${vari} ///
		p99901${vari} p999901${vari} p9990${vari} p999_p99${vari} p9999_p999${vari} ///
		p15$vari p85$vari p8510$vari p8515$vari p8550$vari p5015$vari{
		sum  `vv' if year == `lyear', meanonly
		gen n`vv' = `vv' - r(mean)
		}
	
	*Generate recession vars
	gen rece = inlist(year,${receyears})
	
	*Rescale standard deviation for plots
	replace sd${vari} = 2.56*sd${vari}

	// Keep selected years
	keep if year>=${yrfirst} & year<=${yrlast}	
	
	drop if year==2004 & "$vsample"=="siab"
	
**********************************************
//--- Figure 1 (percentiles) ---//

	local colors blue green red navy black
	local fcolors = ""
	foreach co of local colors {
		local fcolors = "`fcolors'" + " " + "`co'*0.25"
	}
	
*** Figure 1A: normalized percentiles
	if "$vsample"=="long" {
		local yrange="range(-0.2 0.2)"
		local yl = "-0.2(0.1)0.2"
		local lp=7
	}	
	if "$vsample"=="siab" {
		local yrange="range(-0.3 0.3)"
		local yl = "-0.3(0.1)0.3"
		local lp=7
	}
	twoway (bar rece year, c(l) color(gray*0.5) yscale(off) ylabel(,nogrid)) ///
	       (connected np85${vari} np75${vari} np50${vari} np25${vari} np${LP}${vari} year, ///
    			lcolor(`colors')  /// Line colors
    			lpattern(solid longdash dash dash_dot solid) ///
    			msymbol(O + S X D) /// Markers
    			mlcolor(`colors')  /// Marker  line color
                mfcolor(`fcolors')  ///	Fill color
    			yaxis(2)  yscale(alt axis(2) `yrange') ///
                ytitle("Percentiles Relative to `lyear'", axis(2)) ///
                ylabel(`yl', axis(2) grid)),  ///
    	xtitle("") ///
        xlabel(${xlab_sample}, grid) ///
    	legend(position(`lp') order(2 "P85" 3 "P75" 4 "P50" 5 "P25" 6 "P${LP}"))
  cap noisily: graph export "${folderfile}/fig1A_`subgp'_${vari}.${formatfile}", replace


  
********************************************** 
//--- Figure 2 (Inequality) ---//  

	local colors blue red
	local fcolors = ""
	foreach co of local colors {
		local fcolors = "`fcolors'" + " " + "`co'*0.25"
	}

*** Figure 2B: P90-P50 and P50-P10
	local legpos=11
	//if "`subgp'"=="fem" local legpos=5
	if "$vsample"=="long" local yrange="range(0.4 1.0)"
	if "$vsample"=="siab" local yrange="range(0.37 1.0)"	
	twoway (bar rece year, c(l) color(gray*0.5) yscale(off) ylabel(,nogrid)) ///
	       (connected p8550${vari} p50${LP}${vari} year, ///
    			lcolor(`colors')  /// Line colors
    			lpattern(solid longdash) ///
    			msymbol(O S) /// Markers
    			mlcolor(`colors')  /// Marker  line color
                mfcolor(`fcolors')  ///	Fill color
    			yaxis(2)  yscale(alt axis(2) `yrange') ///
                ytitle("Dispersion of `labtitle'", axis(2)) ///
                ylabel(0.4(0.1)1.0, axis(2) grid) ///
            ),  ///
    	xtitle("") ///
        xlabel(${xlab_sample}, grid) ///		xaxis options
    	legend(position(`legpos') order(2 "P85-P50" 3 "P50-P10"))
    cap noisily: graph export "${folderfile}/fig2B_`subgp'_${vari}.${formatfile}", replace

}	// END of loop over subgroups
}	// END loop over variables
}	// END of inequality section
	
//===================================================//
//--- Cohorts and Initial Inequality
//===================================================//

if "${figcoh}" == "yes" { 

//loop over vars
foreach var in logearn {
	
	//loop of subgroups
	foreach subgp in male fem {	
									
	*The code generates for raw earnimgs and residuals earnigs
	global vari = "`var'"		
	
	*Label for plots
	local labtitle = "Log Earnings"
								
	*You can add more groups to this section 
	if "`subgp'" == "all" {
		insheet using "${ineqdata}${sep}L_`var'_age_sumstat.csv", clear
		local tlocal = "All Sample"
	}
	if "`subgp'" == "male" {
		insheet using "${ineqdata}${sep}L_`var'_maleage_sumstat.csv", clear
		keep if male == 1	// Keep the group we want to plot 
		local tlocal = "Men"
	}	
	if "`subgp'" == "fem" {
		insheet using "${ineqdata}${sep}L_`var'_maleage_sumstat.csv", clear
		keep if male == 0	// Keep the group we want to plot 
		local tlocal = "Women"
	}	
			
	*Calculate additional moments 
	gen p99990${vari} = p99_9${vari} - p99${vari}
	gen p9990${vari} = p99${vari} - p90${vari}
	gen p85${LP}${vari} = p85${vari} - p${LP}${vari}	
	gen p8550${vari} = p85${vari} - p50${vari}
	gen p50${LP}${vari} = p50${vari} - p${LP}${vari}
	gen ksk${vari} = (p8550${vari} - p50${LP}${vari})/p85${LP}${vari}

	*Gen cohort that is the age at which cohort was 25 years old 
	gen cohort25 = year - age + 25
	order year age cohort25
		
*************************************
//--- Plots at the age of entry ---//		 			

	local colors blue red
    local fcolors = ""
	foreach co of local colors {
		local fcolors = "`fcolors'" + " " + "`co'*0.25"
	}

	foreach ageval in 25 {
	preserve
		*Keep only the sub sample at the age of age val 
		keep if age == `ageval'
		
		*Rescale by first year 
		foreach vv in sd$vari p1$vari p2_5$vari p5$vari p10$vari p12_5$vari p25$vari ///
			p37_5$vari p50$vari p62_5$vari p75$vari p87_5$vari p90$vari p95$vari ///
			p97_5$vari p99$vari p99_9$vari p99_99$vari ///
			p15$vari p85$vari {
			
			sum  `vv' if year == ${yrfirst}, meanonly
			gen n`vv' = `vv' - r(mean)
			
			}
		*Recessions bars 
		gen rece = inlist(year,${receyears})

		*What is the last year in the x axis 
    	local lyear = ${yrfirst}
    	local ryear = ${yrlast}

		drop if year==2004 & "$vsample"=="siab"
		
*** Percentiles Plot
		if "$vsample"=="long" {
			local yrange="range(0 1.0)"  
			local yl = "0(0.2)1"
		}
		if "$vsample"=="siab" {
			local yrange="range(0 1.2)"
			local yl = "0(0.2)1.2"
		} 
    	twoway (bar rece year, c(l) color(gray*0.5) yscale(off) ylabel(,nogrid)) ///
    	       (connected p8550${vari} p50${LP}${vari} year, ///
        			lcolor(`colors')  /// Line colors
        			lpattern(solid longdash) ///
        			msymbol(O S) /// Markers
        			mlcolor(`colors')  /// Marker  line color
                    mfcolor(`fcolors')  ///	Fill color
        			yaxis(2)  yscale(alt axis(2) `yrange') ///
                    ytitle("Dispersion of `labtitle' at Age 25", axis(2)) ///
                    ylabel(`yl', axis(2) grid) ///
                ),  ///
        	xtitle("") ///
            xlabel(${xlab_sample}, grid) ///		xaxis options
        	legend(position(5) order(2 "P85-P50" 3 "P50-P${LP}"))
        cap noisily: graph export "${folderfile}/fig3_`subgp'_${vari}.${formatfile}", replace 	
		 
	restore
	
	} // END of loop over age val		
	
	
*** Plots by cohorts 			
	*Which variable is under analysis? 
	*The code generates for raw earnimgs and residuals earnigs
	global vari = "`var'"		
	
	*Label for plots
	local labtitle = "log y{sub:it}"
								
	*You can add more groups to this section 
	if "`subgp'" == "all"{
		insheet using "${ineqdata}${sep}L_`var'_age_sumstat.csv", clear
		local tlocal = "All Sample"
	}
	if "`subgp'" == "male"{
		insheet using "${ineqdata}${sep}L_`var'_maleage_sumstat.csv", clear
		keep if male == 1	// Keep the group we want to plot 
		local tlocal = "Men"
	}	
	if "`subgp'" == "fem"{
		insheet using "${ineqdata}${sep}L_`var'_maleage_sumstat.csv", clear
		keep if male == 0	// Keep the group we want to plot 
		local tlocal = "Women"
	}
		
	*Calculate additional moments 
	gen p99990${vari} = p99_9${vari} - p99${vari}
	gen p9990${vari} = p99${vari} - p90${vari}
	gen p85${LP}${vari} = p85${vari} - p${LP}${vari}	
	gen p8550${vari} = p85${vari} - p50${vari}
	gen p50${LP}${vari} = p50${vari} - p${LP}${vari}
	gen ksk${vari} = (p8550${vari} - p50${LP}${vari})/p85${LP}${vari}

	*Gen cohort that is the age at which cohort was 25 years old 
	gen cohort25 = year - age + 25
	order year age cohort25

	drop if year==2004 & "$vsample"=="siab"
	
*** Fig 3B: Gen cohort that is the age at which cohort was 25 years old

	if "$vsample"=="long" {
		local yrange="range(1.0 1.6)"
		local lc=2
		local yl="1.0(0.1)1.6"
	}
	if "$vsample"=="siab" {
		local yrange="range(0.75 1.6)"
		local lc=2
		local yl = "0.8(0.2)1.6"
	}
	plot_cohortage_inequality2 p85${LP}${vari} year, ///
        cohorts(${cohorts}) /// what cohorts
		ages(25 30) /// what ages
        agesarrow(25 30) ///
		twowayoptions( ///
        xlabel(${xlab_sample}, grid) /// x-axis
        ylabel(`yl') yscale(`yrange') ///
		ytitle("P85-P10 of Log Earnings") xtitle("") ///
		) ///
		legpos(5) lcols(`lc') ///
        //arrow1(1.3 2006 1.2 2004 (12) "25 yrs old") // this overrides default in agesarrow		
		cap noisily: graph export "${folderfile}/fig3B_`subgp'_${vari}_2.${formatfile}", replace

	if "$vsample"=="long" {
		local yrange="range(9.7 10.8)"
		local lc=2
	}
	if "$vsample"=="siab" {
		local yrange="range(9.7 10.8)"
		local lc=3
	}	
	plot_cohortage_inequality2 p50${vari} year, ///
        cohorts(${cohorts}) /// what cohorts
		ages(25 30) /// what ages
        agesarrow(25 30) ///
		twowayoptions( ///
        xlabel(${xlab_sample}, grid) /// x-axis
        ylabel(9.8(0.2)10.8) yscale(`yrange') ///
		ytitle("P50 of Log Earnings") xtitle("") ///
		) ///
		legpos(5) lcols(`lc') ///
        //arrow1(1.3 2006 1.2 2004 (12) "25 yrs old") // this overrides default in agesarrow		
		cap noisily: graph export "${folderfile}/fig3B_`subgp'_${vari}_P50.${formatfile}", replace		
		
}	// END loop subgroups
}	// END loop over variables 
}	// END section cohorts
 
//===================================================//	
//--- Volatility
//===================================================//

if "${figvol}" == "yes"{  

*Time series for slides 

	*Plot One-year changes
	foreach jj in 1 { 
		
	global vari = "researn`jj'F"
	
	*Figure 4
	foreach subgp in men women {
		
		if "${vari}" == "researn1F"{
			local lyear = ${yrfirst}
			local ryear = ${yrlast}
			local labtitle = "g{sup:1}{sub:it}"
		}		
		if "${vari}" == "researn5F"{
			local lyear = ${yrfirst} + 2
			local ryear = ${yrlast} - 3	
			local labtitle = "g{sup:5}{sub:it}" // ?? what labels here?
		}
		
		*Load data 				
		insheet using "${voladata}${sep}L_${vari}_male_sumstat.csv", case clear
		
		if "`subgp'" == "men"{
			keep if male == 1
		}
		else{
			keep if male == 0
		}	
		
		// Recession years
		gen rece = inlist(year,${receyears})
		
		gen p9050$vari = p90$vari - p50$vari
		//gen p5010$vari = p50$vari - p10$vari
		gen p8550$vari = p85$vari - p50$vari
		gen p50${LP}$vari = p50$vari - p${LP}$vari		
		
		
		// This is to center the 5-year changes
		if "${vari}" == "researn5F" {
			replace year = year + 2
		}

*********************************************************
//--- Figure 4 (Volatility, Dispersion P9050 P5010) ---//		

		//colors
		local colors blue red
		local fcolors = ""
		foreach co of local colors {
			local fcolors = "`fcolors'" + " " + "`co'*0.25"
		}

		//legend position
		local legpos=5 //11
		//if "`subgp'"=="women" local legpos=5
		
		if "$vsample"=="long" local yrange="range(0.0 0.3)"
		if "$vsample"=="siab" local yrange="range(0.0 0.4)"
		drop if year==2004 & "$vsample"=="siab"
		twoway (bar rece year, c(l) color(gray*0.5) yscale(off) ylabel(,nogrid)) ///
		       (connected p8550${vari} p50${LP}${vari} year, ///
		    			lcolor(`colors')  /// Line colors
		    			lpattern(solid longdash) ///
		    			msymbol(O S) /// Markers
		    			mlcolor(`colors')  /// Marker  line color
		                mfcolor(`fcolors')  ///	Fill color
		    			yaxis(2)  yscale(alt axis(2) `yrange') ///
              ytitle("Dispersion of `labtitle'", axis(2)) ///
              ylabel(0(0.1)0.4, axis(2) grid) ///
	            ),  ///
			    	xtitle("") ///
			      xlabel(${xlab_sample}, grid) ///		xaxis options
			    	legend(position(`legpos') order(2 "P85-P50" 3 "P50-P${LP}"))
	  cap noisily: graph export "${folderfile}/fig4_`subgp'_${vari}.${formatfile}", replace

	} // subgp
	
********************************************************
//--- Figure 5 (Skewness and Kurtosis time series) ---//

	//data
	insheet using "${voladata}${sep}L_${vari}_male_sumstat.csv", case clear
	
	//colors
	local colors red blue
	local fcolors = ""
	foreach co of local colors {
		local fcolors = "`fcolors'" + " " + "`co'*0.25"
	}
	
	gen ksk${vari} = ((p85${vari} - p50${vari}) - (p50${vari} - p${LP}${vari}) )/(p85$vari - p${LP}${vari})
	gen cku${vari} = (p97_5${vari} - p2_5${vari})/(p75$vari - p25${vari}) - 2.91
	
	//reshape
	keep year male ksk${vari} cku${vari}
	reshape wide ksk${vari} cku${vari}, i(year) j(male)
	
	//recession years
	gen rece = inlist(year,${receyears})
	
	// This is to center the 5-year changes
	if "${vari}" == "researn5F" {
		replace year = year + 2
	}
	
*** Figure 5A (Skewness)

*** Figure 5B (Kurtosis)

	}	// END loop jj
} // END section Volatility

*------------------------------------------------------------------------------*

*END OF THE CODE
