*! 20220511 hw
//==========================================================================================
// This program generates data sets containing topcoding / censoring measures
// GRID project
//==========================================================================================


*** censored from IEB
use "${root}\dta\ieb_10perc_clean.dta", clear

keep persid censor year

collapse (max) censor, by(persid year)
label var censor " censored spell for worker this year"

save "${root}\dta\pers_year_censor.dta", replace
clear


*** core code for main data file (non-imputed)

do "${prog}/0_initialize_nonimp"
do "${prog}/1_Gen_Base_Sample_nonimp"


*** censor to main data file

use "${data}\master_sample_nonimp.dta", clear

rename personid persid

reshape long labor logearn logearnc permearn permearnalt researn researnc researn1F researn5F arcearn1F arcearn5F , ///
				i(persid) j(year)

merge 1:1 persid year using "${root}\dta\pers_year_censor.dta"

drop _merge

save "${data}\master_sample_nonimp_cens.dta", replace


clear

********************************************************************************
