*! v20220525 hw
//==========================================================================================
// This program generates shares of topcoded earnings in IAB data
// GRID project
//==========================================================================================

//=== incl. using topcoding ===//

foreach ct in "cens"  { 
		
	*loop over definitions
	forval def=2 { 
		
		* loop over rank-topcoding order
		forval ro=2 {
			
			//--- all gender and all age groups ---//

			use permearnalt_rank_vol_`ct'`def'_v1 permearnalt_rank_vol_`ct'`def'_v2 permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
				topcodedPerm`def'_vol_`ct' permearnalt_pctls_vol_`ct'`def'_v1 permearnalt_pctls_vol_`ct'`def'_v2 C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def' ///
				permearnalt_rank_mob_`ct'`def'_v1 permearnalt_rank_mob_`ct'`def'_v2 permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
				topcodedPerm`def'_mob_`ct' permearnalt_pctls_mob_`ct'`def'_v1 permearnalt_pctls_mob_`ct'`def'_v2 C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def' ///
				const_one year male agegp ///
				using "${data}/data_topcoded_all.dta", clear			
			
			* vol
			preserve
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_vol_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_vol_`ct'`def'_v`ro' permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
					topcodedPerm`def'_vol_`ct' const_one year permearnalt_pctls_vol_`ct'`def'_v`ro' C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def'

			collapse (mean) avg_pct_year_t_1_log_inc=permearnalt_rank_vol_`ct'`def'_v`ro' avg_pct_year_t_1_log_inc_valmiss=permearnalt_rank_vol_`ct'`def'_v5 ///
							avg_pct_year_t_1_log_inc_valCO=permearnalt_rank_vol_`ct'`def'_v4 avg_pct_year_t_1_log_inc_val100=permearnalt_rank_vol_`ct'`def'_v3 ///
							share_topcoded_t_1_log_inc=topcodedPerm`def'_vol_`ct' ///
							cutoff_lb_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_lb_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(sum) N=const_one, by(year permearnalt_pctls_vol_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_valCO avg_pct_year_t_1_log_inc_val100 share_topcoded_t_1_log_inc avg_pct_year_t_1_log_inc_valmiss {
				replace `var'=.n if N<20
			}			

			rename permearnalt_pctls_vol_`ct'`def'_v`ro' pct_year_t_log_earnings 
							
			gen country = "GER"
			gen gender = "All genders"
			gen age = "25-55"
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_val* share_topcoded_t_1_log_inc cutoff_lb_pctl_topcoded_t_1 cutoff_lb_rank_topcoded_t_1	 	
			tempfile mob_temp1v			
			save `mob_temp1v'
			restore

			* mob
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_mob_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_mob_`ct'`def'_v`ro' permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
					topcodedPerm`def'_mob_`ct' const_one year permearnalt_pctls_mob_`ct'`def'_v`ro' C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def'
					
			collapse (mean) avg_pct_year_t_5_log_inc=permearnalt_rank_mob_`ct'`def'_v`ro' avg_pct_year_t_5_log_inc_valmiss=permearnalt_rank_mob_`ct'`def'_v5 ///
							avg_pct_year_t_5_log_inc_valCO=permearnalt_rank_mob_`ct'`def'_v4 avg_pct_year_t_5_log_inc_val100=permearnalt_rank_mob_`ct'`def'_v3 ///
							share_topcoded_t_5_log_inc=topcodedPerm`def'_mob_`ct' ///
							cutoff_lb_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_lb_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(sum) N=const_one, by(year permearnalt_pctls_mob_`ct'`def'_v`ro')


			foreach var in avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_valCO avg_pct_year_t_5_log_inc_val100 avg_pct_year_t_5_log_inc_valmiss share_topcoded_t_5_log_inc {
				replace `var'=.n if N<20
			}	

			rename permearnalt_pctls_mob_`ct'`def'_v`ro' pct_year_t_log_earnings 
							
			gen country = "GER"
			gen gender = "All genders"
			gen age = "25-55"
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_val* share_topcoded_t_5_log_inc cutoff_lb_pctl_topcoded_t_5 cutoff_lb_rank_topcoded_t_5			
			tempfile mob_temp1m			
			save `mob_temp1m'
			clear


			//--- all gender but by age groups ---//

			use permearnalt_rank_vol_`ct'`def'_v1 permearnalt_rank_vol_`ct'`def'_v2 permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
				topcodedPerm`def'_vol_`ct' permearnalt_pctls_vol_`ct'`def'_v1 permearnalt_pctls_vol_`ct'`def'_v2 C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def' ///
				permearnalt_rank_mob_`ct'`def'_v1 permearnalt_rank_mob_`ct'`def'_v2 permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
				topcodedPerm`def'_mob_`ct' permearnalt_pctls_mob_`ct'`def'_v1 permearnalt_pctls_mob_`ct'`def'_v2 C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def' ///
				const_one year male agegp ///
				using "${data}/data_topcoded_age.dta", clear	
			
			* vol
			preserve
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_vol_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_vol_`ct'`def'_v`ro' permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
					topcodedPerm`def'_vol_`ct' const_one year agegp permearnalt_pctls_vol_`ct'`def'_v`ro' C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def'	
			
			collapse (mean) avg_pct_year_t_1_log_inc=permearnalt_rank_vol_`ct'`def'_v`ro' avg_pct_year_t_1_log_inc_valmiss=permearnalt_rank_vol_`ct'`def'_v5 ///
							avg_pct_year_t_1_log_inc_valCO=permearnalt_rank_vol_`ct'`def'_v4 avg_pct_year_t_1_log_inc_val100=permearnalt_rank_vol_`ct'`def'_v3 ///
							share_topcoded_t_1_log_inc=topcodedPerm`def'_vol_`ct' ///
						(min) cutoff_lb_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_lb_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(max) cutoff_ub_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_ub_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(sum) N=const_one, by(year agegp permearnalt_pctls_vol_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_valCO avg_pct_year_t_1_log_inc_val100 avg_pct_year_t_1_log_inc_valmiss share_topcoded_t_1_log_inc {
				replace `var'=.n if N<20
			}

			rename permearnalt_pctls_vol_`ct'`def'_v`ro' pct_year_t_log_earnings

			gen country = "GER"
			gen gender = "All genders"
			gen age = ""
			replace age = "25-34" if agegp==1
			replace age = "35-44" if agegp==2
			replace age = "45-55" if agegp==3
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_val* share_topcoded_t_1_log_inc ///
					cutoff_lb_pctl_topcoded_t_1 cutoff_lb_rank_topcoded_t_1	cutoff_ub_pctl_topcoded_t_1 cutoff_ub_rank_topcoded_t_1				
			tempfile mob_temp2v			
			save `mob_temp2v'
			restore

			* mob
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_mob_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_mob_`ct'`def'_v`ro' permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
					topcodedPerm`def'_mob_`ct' const_one year agegp permearnalt_pctls_mob_`ct'`def'_v`ro' C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def'		
			
			collapse (mean) avg_pct_year_t_5_log_inc=permearnalt_rank_mob_`ct'`def'_v`ro' avg_pct_year_t_5_log_inc_valmiss=permearnalt_rank_mob_`ct'`def'_v5 ///
							avg_pct_year_t_5_log_inc_valCO=permearnalt_rank_mob_`ct'`def'_v4 avg_pct_year_t_5_log_inc_val100=permearnalt_rank_mob_`ct'`def'_v3 ///
							share_topcoded_t_5_log_inc=topcodedPerm`def'_mob_`ct' ///
						(min) cutoff_lb_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_lb_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(max) cutoff_ub_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_ub_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(sum) N=const_one, by(year agegp permearnalt_pctls_mob_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_valCO avg_pct_year_t_5_log_inc_val100 avg_pct_year_t_5_log_inc_valmiss share_topcoded_t_5_log_inc {
				replace `var'=.n if N<20
			}	

			rename permearnalt_pctls_mob_`ct'`def'_v`ro' pct_year_t_log_earnings 

			gen country = "GER"
			gen gender = "All genders"
			gen age = ""
			replace age = "25-34" if agegp==1
			replace age = "35-44" if agegp==2
			replace age = "45-55" if agegp==3
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_val* share_topcoded_t_5_log_inc  ///
					cutoff_lb_pctl_topcoded_t_5 cutoff_lb_rank_topcoded_t_5 cutoff_ub_pctl_topcoded_t_5 cutoff_ub_rank_topcoded_t_5						
			tempfile mob_temp2m			
			save `mob_temp2m'
			clear


			//--- by gender but all age groups ---//

			use permearnalt_rank_vol_`ct'`def'_v1 permearnalt_rank_vol_`ct'`def'_v2 permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
				topcodedPerm`def'_vol_`ct' permearnalt_pctls_vol_`ct'`def'_v1 permearnalt_pctls_vol_`ct'`def'_v2 C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def' ///
				permearnalt_rank_mob_`ct'`def'_v1 permearnalt_rank_mob_`ct'`def'_v2 permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
				topcodedPerm`def'_mob_`ct' permearnalt_pctls_mob_`ct'`def'_v1 permearnalt_pctls_mob_`ct'`def'_v2 C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def' ///
				const_one year male agegp  ///
				using "${data}/data_topcoded_male.dta", clear			
			
			* vol
			preserve
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_vol_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_vol_`ct'`def'_v`ro' permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
					topcodedPerm`def'_vol_`ct' const_one year male permearnalt_pctls_vol_`ct'`def'_v`ro' C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def'
	
			collapse (mean) avg_pct_year_t_1_log_inc=permearnalt_rank_vol_`ct'`def'_v`ro' avg_pct_year_t_1_log_inc_valmiss=permearnalt_rank_vol_`ct'`def'_v5 ///
							avg_pct_year_t_1_log_inc_valCO=permearnalt_rank_vol_`ct'`def'_v4 avg_pct_year_t_1_log_inc_val100=permearnalt_rank_vol_`ct'`def'_v3 ///
							share_topcoded_t_1_log_inc=topcodedPerm`def'_vol_`ct' ///
							cutoff_lb_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_lb_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(sum) N=const_one, by(year male permearnalt_pctls_vol_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_valCO avg_pct_year_t_1_log_inc_val100 avg_pct_year_t_1_log_inc_valmiss share_topcoded_t_1_log_inc {
				replace `var'=.n if N<20
			}

			rename permearnalt_pctls_vol_`ct'`def'_v`ro' pct_year_t_log_earnings

			gen country = "GER"
			gen gender = ""
			replace gender = "male" if male==1
			replace gender = "female" if male==0
			gen age = "25-55"
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_val* share_topcoded_t_1_log_inc cutoff_lb_pctl_topcoded_t_1 cutoff_lb_rank_topcoded_t_1			
			tempfile mob_temp3v			
			save `mob_temp3v'
			restore

			* mob
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_mob_`ct'`def'_v`ro'==.
			keep permearnalt_rank_mob_`ct'`def'_v`ro' permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
					topcodedPerm`def'_mob_`ct' const_one year male permearnalt_pctls_mob_`ct'`def'_v`ro' C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def'
			
			collapse (mean) avg_pct_year_t_5_log_inc=permearnalt_rank_mob_`ct'`def'_v`ro' avg_pct_year_t_5_log_inc_valmiss=permearnalt_rank_mob_`ct'`def'_v5 ///
							avg_pct_year_t_5_log_inc_valCO=permearnalt_rank_mob_`ct'`def'_v4 avg_pct_year_t_5_log_inc_val100=permearnalt_rank_mob_`ct'`def'_v3 ///
							share_topcoded_t_5_log_inc=topcodedPerm`def'_mob_`ct' ///
							cutoff_lb_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_lb_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(sum) N=const_one, by(year male permearnalt_pctls_mob_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_valCO avg_pct_year_t_5_log_inc_val100 avg_pct_year_t_5_log_inc_valmiss share_topcoded_t_5_log_inc {
				replace `var'=.n if N<20
			}	

			rename permearnalt_pctls_mob_`ct'`def'_v`ro' pct_year_t_log_earnings 

			gen country = "GER"
			gen gender = ""
			replace gender = "male" if male==1
			replace gender = "female" if male==0
			gen age = "25-55"
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_val* share_topcoded_t_5_log_inc cutoff_lb_pctl_topcoded_t_5 cutoff_lb_rank_topcoded_t_5				
			tempfile mob_temp3m		
			save `mob_temp3m'
			clear
			

			//--- by gender AND age group ---//

			use permearnalt_rank_vol_`ct'`def'_v1 permearnalt_rank_vol_`ct'`def'_v2 permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
				topcodedPerm`def'_vol_`ct' permearnalt_pctls_vol_`ct'`def'_v1 permearnalt_pctls_vol_`ct'`def'_v2 C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def' ///
				permearnalt_rank_mob_`ct'`def'_v1 permearnalt_rank_mob_`ct'`def'_v2 permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
				topcodedPerm`def'_mob_`ct' permearnalt_pctls_mob_`ct'`def'_v1 permearnalt_pctls_mob_`ct'`def'_v2 C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def' ///
				const_one year male agegp ///
				using "${data}/data_topcoded_maleage.dta", clear			
			
			* vol
			preserve
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_vol_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_vol_`ct'`def'_v`ro' permearnalt_rank_vol_`ct'`def'_v3 permearnalt_rank_vol_`ct'`def'_v4 permearnalt_rank_vol_`ct'`def'_v5 ///
					topcodedPerm`def'_vol_`ct' const_one year male agegp permearnalt_pctls_vol_`ct'`def'_v`ro' C_cutoff_permearnalt_vol_`ct'`def' F_cutoff_permearnalt_vol_`ct'`def'
			
			collapse (mean) avg_pct_year_t_1_log_inc=permearnalt_rank_vol_`ct'`def'_v`ro' avg_pct_year_t_1_log_inc_valmiss=permearnalt_rank_vol_`ct'`def'_v5 ///
							avg_pct_year_t_1_log_inc_valCO=permearnalt_rank_vol_`ct'`def'_v4 avg_pct_year_t_1_log_inc_val100=permearnalt_rank_vol_`ct'`def'_v3 ///
							share_topcoded_t_1_log_inc=topcodedPerm`def'_vol_`ct' ///
						(min) cutoff_lb_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_lb_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(max) cutoff_ub_pctl_topcoded_t_1=C_cutoff_permearnalt_vol_`ct'`def' cutoff_ub_rank_topcoded_t_1=F_cutoff_permearnalt_vol_`ct'`def' ///
						(sum) N=const_one, by(year male agegp permearnalt_pctls_vol_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_valCO avg_pct_year_t_1_log_inc_val100 avg_pct_year_t_1_log_inc_valmiss share_topcoded_t_1_log_inc {
				replace `var'=.n if N<20
			}

			rename permearnalt_pctls_vol_`ct'`def'_v`ro' pct_year_t_log_earnings

			gen country = "GER"
			gen gender = ""
			replace gender = "male" if male==1
			replace gender = "female" if male==0
			gen age = ""
			replace age = "25-34" if agegp==1
			replace age = "35-44" if agegp==2
			replace age = "45-55" if agegp==3
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_val* share_topcoded_t_1_log_inc ///
					cutoff_lb_pctl_topcoded_t_1 cutoff_lb_rank_topcoded_t_1	cutoff_ub_pctl_topcoded_t_1 cutoff_ub_rank_topcoded_t_1	
			tempfile mob_temp4v			
			save `mob_temp4v'
			restore

			* mob
			drop if year==. | male==. | agegp==. 
			drop if permearnalt_pctls_mob_`ct'`def'_v`ro'==. 
			keep permearnalt_rank_mob_`ct'`def'_v`ro' permearnalt_rank_mob_`ct'`def'_v3 permearnalt_rank_mob_`ct'`def'_v4 permearnalt_rank_mob_`ct'`def'_v5 ///
					topcodedPerm`def'_mob_`ct' const_one year male agegp permearnalt_pctls_mob_`ct'`def'_v`ro' C_cutoff_permearnalt_mob_`ct'`def' F_cutoff_permearnalt_mob_`ct'`def'
			
			collapse (mean) avg_pct_year_t_5_log_inc=permearnalt_rank_mob_`ct'`def'_v`ro' avg_pct_year_t_5_log_inc_valmiss=permearnalt_rank_mob_`ct'`def'_v5 ///
							avg_pct_year_t_5_log_inc_valCO=permearnalt_rank_mob_`ct'`def'_v4 avg_pct_year_t_5_log_inc_val100=permearnalt_rank_mob_`ct'`def'_v3 ///
							share_topcoded_t_5_log_inc=topcodedPerm`def'_mob_`ct' ///
						(min) cutoff_lb_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_lb_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(max) cutoff_ub_pctl_topcoded_t_5=C_cutoff_permearnalt_mob_`ct'`def' cutoff_ub_rank_topcoded_t_5=F_cutoff_permearnalt_mob_`ct'`def'  ///
						(sum) N=const_one, by(year male agegp permearnalt_pctls_mob_`ct'`def'_v`ro')

			foreach var in avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_valCO avg_pct_year_t_5_log_inc_val100 avg_pct_year_t_5_log_inc_valmiss share_topcoded_t_5_log_inc {
				replace `var'=.n if N<20
			}	

			rename permearnalt_pctls_mob_`ct'`def'_v`ro' pct_year_t_log_earnings 

			gen country = "GER"
			gen gender = ""
			replace gender = "male" if male==1
			replace gender = "female" if male==0
			gen age = ""
			replace age = "25-34" if agegp==1
			replace age = "35-44" if agegp==2
			replace age = "45-55" if agegp==3
			label def pct_year_t_log_earnings_lbl 101 "topcoded"
			lab val pct_year_t_log_earnings pct_year_t_log_earnings_lbl
			
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_val* share_topcoded_t_5_log_inc ///
					cutoff_lb_pctl_topcoded_t_5 cutoff_lb_rank_topcoded_t_5 cutoff_ub_pctl_topcoded_t_5 cutoff_ub_rank_topcoded_t_5	 	
			tempfile mob_temp4m			
			save `mob_temp4m'
			clear


			//--- Collect mobility rank file ---//

			use `mob_temp1v', clear
			append using `mob_temp2v'
			append using `mob_temp3v'
			append using `mob_temp4v'

			merge 1:1 year gender age pct_year_t_log_earnings using `mob_temp1m', update
			drop _merge
			merge 1:1 year gender age pct_year_t_log_earnings using `mob_temp2m', update
			drop _merge
			merge 1:1 year gender age pct_year_t_log_earnings using `mob_temp3m', update
			drop _merge
			merge 1:1 year gender age pct_year_t_log_earnings using `mob_temp4m', update
			drop _merge

			order country year gender age pct_year_t_log_earnings ///
				avg_pct_year_t_1_log_inc avg_pct_year_t_1_log_inc_valCO avg_pct_year_t_1_log_inc_val100 avg_pct_year_t_1_log_inc_valmiss share_topcoded_t_1_log_inc ///
				avg_pct_year_t_5_log_inc avg_pct_year_t_5_log_inc_valCO avg_pct_year_t_5_log_inc_val100 avg_pct_year_t_5_log_inc_valmiss share_topcoded_t_5_log_inc ///
				cutoff_lb_pctl_topcoded_t_1 cutoff_lb_pctl_topcoded_t_5 cutoff_ub_pctl_topcoded_t_1 cutoff_ub_pctl_topcoded_t_5 ///
				cutoff_lb_rank_topcoded_t_1 cutoff_lb_rank_topcoded_t_5 cutoff_ub_rank_topcoded_t_1 cutoff_ub_rank_topcoded_t_5 
			sort year gender age pct_year_t_log_earnings
			keep country year gender age pct_year_t_log_earnings avg_pct_year_t_1_log_inc avg_pct_year_t_5_log_inc 
			export delimited using "${fileout}/mobility_GER_IABsample_topcoded.csv", replace
			export delimited using "${fileout}/mobility_GER_IABsample_topcoded_nol.csv", replace nolab
			clear
		
		}
	}
}	

********************************************************************************
