clear all
set more off
version 15
pause off
set logtype text
set linesize 255
mata mata mlib index
set maxvar 20000

pause off
*set trace on

//=======================================================================================
// 1. Define User / Paths / Dataset
//=======================================================================================

// debugging mode
global debug = 0

// apply data privacy protection rules
global protect = 1	// with kdfv, this is always 1 (even when there is a zero here)

// Vollmaterial
global vollmaterial = 1
global vollmaterial_subsample = 0.25


// More settings
global csvdelim			= ","
if $vollmaterial == 1  	global samplesize = $vollmaterial_subsample
else 										global samplesize = 0.05
global debug = 0
global protect = 1
/* sysdir set PERSONAL "XXX"
sysdir set PLUS "XXX" */
mata: mata mlib index

// Define more subfolders
//----------------------------------------------------

global log_folder		=	"${out_folder}"
global figs_folder	=	"${out_folder}"
global tabs_folder	=	"${out_folder}"

// Make sure folders exist
//----------------------------------------------------
cap mkdir "${dta_folder}"
cap mkdir "${log_folder}"
cap mkdir "${out_folder}"
cap mkdir "${figs_folder}"
cap mkdir "${tabs_folder}"

// Change directory
cd "${main_folder}"


// Gtools ado
//----------------------------------------------------

/*
	Teile von gtools werden nicht erkannt, sodass die gtools-commands nicht ausführbar sind.
	Laut der Diskussion hier (https://github.com/mcaceresb/stata-gtools/issues/61), muss man wohl manchmal 
	gtools nochmal upgraden (oder neu installieren), oder die Zeile "mata: mata mlib index" einfügen.
	Diese Zeile steht zwar schon ganz oben im Master, aber ich vermute, dass man sie wiederholen muss nachdem
	man die sysdir Pfade anpasst, was bei user=kdfv geschieht.
*/

adopath ++ "FDZ-PATH\stata_ado" /* require gtools */
mata: mata mlib index


// Name of base data
//----------------------------------------------------
if $vollmaterial == 1 {
	local subpct = 100 * $vollmaterial_subsample
	global BASEDATA = "BASEDATA_vollmaterial_`subpct'"
}
else {
	global BASEDATA = "BASEDATA_tpp"
} 

// Use only "Rentenversicherungspflichtige"
global rvonly = "yes" // Use only "Rentenversicherungspflichtige"
global foldersuffix = " (labor, rv)"


//=======================================================================================
// 3. Get Date for Log Files
//=======================================================================================

global date = "YYYY-MM-DD" 


//=======================================================================================
// 4. Analysis Settings
//=======================================================================================

qui do "${do_folder}/001_Initialize.do"
