cap program drop append_and_export
program append_and_export
  syntax , filestub(string) years(numlist) [dataprivacy(string) var(string) *]
  // append annual files
  clear 
  foreach yr of numlist `years' {
    append using "`filestub'`yr'"
    //erase "`filestub'`yr'.dta"
  }
  // DATA PRIVACY
	local comma = cond("`options'" == "", "", ",")
	if "`dataprivacy'" == "" local dataprivacy data_privacy_sumstats
  if $protect == 1 `dataprivacy' `var' `comma' `options'
  // Export
  if substr("`filestub'", -1, .) == "_" local outstub = substr("`filestub'", 1, `= strlen("`filestub'") -1')
  else local outstub `filestub'
  export delimited using "`outstub'.csv", delimiter("$csvdelim") replace
  noi disp "save to CSV: $outfolder/`outstub'.csv"
end

cap program drop data_privacy_density
program define data_privacy_density
	local varname = "`1'"
	replace value_`varname' = . if N < 30
	replace density_`varname' = . if N < 30
	replace N = . if N < 30
end

cap program drop data_privacy_sumstats
program data_privacy_sumstats
	local varname = "`1'"
	foreach v of varlist mean* {
		cap replace `v' = . if N < 30 
	}
	cap replace min`varname' 		= .
	cap replace max`varname' 		= .
	cap replace mean`varname' 	= . if N < 30
	cap replace sd`varname' 		= . if N < 30
	cap replace m2`varname' = . if N < 30
	cap replace m3`varname' = . if N < 30
	cap replace m4`varname' = . if N < 30
	cap replace skew`varname' = . if N < 30
	cap replace kurt`varname' = . if N < 30
	cap replace gini`varname' = . if N < 30
	cap replace theil`varname' = . if N < 30
	foreach var of varlist p*`varname' {
		local p = subinstr(substr("`var'", 2, .), "`varname'", "", .)
		local p = subinstr("`p'", "_", ".", .)
		replace `var' = . if N < max(30, ceil(100 / min(100-`p', `p') * 3))
	}
	cap replace sum_weights = . if N < 30
	replace N = . if N < 30
end

cap program drop data_privacy_mean
program data_privacy_mean
  foreach var of varlist mean* {
    replace `var' 	= . if N < 30
  }
	replace N = . if N < 30
	cap replace sum_weights = . if N == .
end
