//=======================================================================================
// Preamble
//=======================================================================================
clear all

global mydate = "YYYY-MM-DD" // ADJUST THIS

// Main folders and raw data
//----------------------------------------------------------

global main_folder 	= "ENTER YOUR PATH"
global tpp_folder   = "$main_folder/PATH TO TPP-RESULTS FOLDERS"
global iab_folder   = "$main_folder/PATH TO IAB-RESULTS FOLDERS"
global joint_folder = "$main_folder/PATH TO JOINT-RESULTS FOLDERS"

global do_folder		=	"${main_folder}/PATH TO DO-FILES"
global figs_folder		=	"${main_folder}/PATH WHERE FIGURES AND TABLES ARE STORED" // ADJUST THIS
cap mkdir "$figs_folder"
cap mkdir "$figs_folder/data"
cap mkdir "$figs_folder/core"
cap mkdir "$figs_folder/specific"
cap mkdir "$figs_folder/app-tppiab"

// Remaining settings
//----------------------------------------------------------
qui do "${do_folder}/001_Initialize.do"
qui do "${do_folder}/myplotsettings.do"

qui do "${do_folder}/programs_general"
qui do "${do_folder}/programs_figures"
qui do "${do_folder}/programs_tables"

cd "$main_folder"

global label_labor = "Workers"
global label_nonlabor = "Entrepreneurs"
global label_self = "Self-Employed"
global label_business = "Business Owners"
global label_rental = "Landlords"

global colors_mainsrc2 = "blue red"
global symbols_mainsrc2 = "O S"
global patterns_mainsrc2 = "solid dash"

global colors_mainsrc4 = "blue red green navy"
global symbols_mainsrc4 = "O S D T"
global patterns_mainsrc4 = "solid dash longdash shortdash"


/*

//=======================================================================================
// House Keeping
//=======================================================================================

qui do "${do_folder}/postanalysis/102_common_delimiter.do"

qui do "${do_folder}/postanalysis/101_fill_missing_income_shares.do"


//=======================================================================================
// Create figures
//=======================================================================================

qui do "${do_folder}/postanalysis/200_descriptives_tppiab.do"

qui do "${do_folder}/postanalysis/201_core_inequality.do"

qui do "${do_folder}/postanalysis/202_core_volatility.do"
