//=======================================================================================
// MAIN FIGURES
//=======================================================================================

cd "$joint_folder"

load_csvdata, filename("$joint_folder/mobility/sumstats_respermearnalt5F_by_rankrespermearnalt_maleagegp.csv") dropsuffix(respermearnalt5F)

//=======================================================================================
// MAIN FIGURES
//=======================================================================================

cd "$joint_folder"

load_csvdata, filename("$joint_folder/mobility/sumstats_rankrespermearnalt5F_by_rankrespermearnalt_maleagegp.csv")

twoway (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 1 & agegp == 1 & year == 2005, lcolor(red) lpattern(solid) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 1 & agegp == 1 & year == 2011, lcolor(red) lpattern(dash) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 1 & agegp == 2 & year == 2005, lcolor(blue) lpattern(solid) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 1 & agegp == 2 & year == 2011, lcolor(blue) lpattern(dash) lwidth(*2)) ///
       (function y = x, range(0 100) lpat(dash) lcol(gs5)), legend(position(11) order(1 "[25-34], 2005" 2 "[25-34], 2011" 3 "[35-44], 2005" 4 "[35-44], 2011")) ///
       xlabel(#10) ///
       ytitle("Mean Percentiles of P{sub:it+5}") xtitle("Percentiles of Permanent Earnings, P{sub:it}")
graph export "$figs_folder/core/rankrespermearnalt5F_mean_by_rankrespermearnalt_male.pdf", replace
 
twoway (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 0 & agegp == 1 & year == 2005, lcolor(red) lpattern(solid) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 0 & agegp == 1 & year == 2011, lcolor(red) lpattern(dash) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 0 & agegp == 2 & year == 2005, lcolor(blue) lpattern(solid) lwidth(*2)) ///
       (line meanrankrespermearnalt5F_adj rankrespermearnalt if male == 0 & agegp == 2 & year == 2011, lcolor(blue) lpattern(dash) lwidth(*2)) ///
       (function y = x, range(0 100) lpat(dash) lcol(gs5)), legend(position(11) order(1 "[25-34], 2005" 2 "[25-34], 2011" 3 "[35-44], 2005" 4 "[35-44], 2011")) ///
       xlabel(#10) ///
       ytitle("Mean Percentiles of P{sub:it+5}") xtitle("Percentiles of Permanent Earnings, P{sub:it}")
graph export "$figs_folder/core/rankrespermearnalt5F_mean_by_rankrespermearnalt_female.pdf", replace 
 
 